package com.hz.pm.api.projectdeclared.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Lists;
import com.hz.pm.api.projectdeclared.mapper.XinchuangMapper;
import com.hz.pm.api.projectdeclared.model.entity.Purchase;
import com.hz.pm.api.projectdeclared.model.entity.Xinchuang;
import com.hz.pm.api.projectdeclared.model.req.XcfhxListReq;
import com.hz.pm.api.projectdeclared.model.vo.XcfhxApplyListVO;
import com.hz.pm.api.projectdeclared.service.IXinchuangService;
import com.hz.pm.api.projectlib.model.enumeration.status.TenderXcfhxApplyStatus;
import com.hz.pm.api.user.security.model.UserFullInfoDTO;
import com.hz.pm.api.user.util.LoginUserUtil;
import com.ningdatech.basic.model.PageVo;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zpf
 * @since 2024-07-02
 */
@Service
public class XinchuangServiceImpl extends ServiceImpl<XinchuangMapper, Xinchuang>
        implements IXinchuangService {

    @Override
    public List<XcfhxApplyListVO> listXcfhxApplyListVO(XcfhxListReq req) {
        LambdaQueryWrapper<Xinchuang> query = Wrappers.lambdaQuery(Xinchuang.class)
                .like(StrUtil.isNotBlank(req.getBidName()), Xinchuang::getBidName, req.getBidName())
                .like(StrUtil.isNotBlank(req.getProjectName()), Xinchuang::getProjectName, req.getProjectName())
                .le(req.getCreateOnMax() != null, Xinchuang::getCreateOn, req.getCreateOnMax())
                .ge(req.getCreateOnMin() != null, Xinchuang::getCreateOn, req.getCreateOnMin())
                .eq(req.getStatus() != null, Xinchuang::getStatus, req.getStatus())
                .eq(req.getSourceType() != null,Xinchuang::getSourceType,req.getSourceType())
                //如果查金额 就查不到 手动新增的
                .eq(req.getAmountStart() != null, Xinchuang::getId, 0L)
                .eq(req.getAmountEnd() != null, Xinchuang::getId, 0L)
                .orderByDesc(Xinchuang::getCreateOn);
        if (Boolean.TRUE.equals(req.getFinished())) {
            query.eq(Xinchuang::getStatus, TenderXcfhxApplyStatus.XCFHX_APPLY_PASSED.getCode());
        } else if (Boolean.FALSE.equals(req.getFinished())){
            query.ne(Xinchuang::getStatus, TenderXcfhxApplyStatus.XCFHX_APPLY_PASSED.getCode());
        }
        List<Xinchuang> list = list(query);
        return list.stream().map(x -> BeanUtil.copyProperties(x,XcfhxApplyListVO.class))
                .collect(Collectors.toList());
    }
}
